package org.openntf.sourcesniffer.views;

/*
 * (C)Copyright Ferry Kranenburg 2010
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at:
 * 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * permissions and limitations under the License.
 */

import org.eclipse.core.internal.resources.Project;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.internal.AggregateWorkingSet;
import org.eclipse.ui.internal.WorkingSet;
import org.openntf.sourcesniffer.Activator;

import com.ibm.designer.domino.ide.resources.extensions.DesignerProject;
import com.ibm.designer.domino.ui.commons.extensions.DesignerResource;


@SuppressWarnings("restriction")
public class ssTreeWorkingSetLabelProvider implements ILabelProvider {

	@Override
	public Image getImage(Object inputElement) {
//		String imagePath =  ssTools.getAttributeByName((Node) inputElement, "ss_Image", true, false );
		if (inputElement instanceof WorkingSet){
			return new Image(null, Activator.getImage("icons/folder20.png"), 0);
		}else{
			return new Image(null, Activator.getImage("icons/add20.png"), 0);
		}

	}

	@Override
	public String getText(Object inputElement) {
		
		
		if (inputElement instanceof AggregateWorkingSet){
			return ((AggregateWorkingSet) inputElement).getLabel(); 
		}
		
		
		if (inputElement instanceof WorkingSet){
			return ((WorkingSet) inputElement).getLabel(); 
		}else{
			if (inputElement instanceof Project){
				DesignerProject desprj = DesignerResource.getDesignerProject(((Project) inputElement).getProject());

				if (desprj.getServerCommonName() != null) {
					return desprj.getDatabaseTitle()  + " (" +  desprj.getServerCommonName().toString() + ")";
				}else{
					return desprj.getDatabaseTitle();
				}
				
			}else{
				return null;
			}
		}
		
	}

	@Override
	public void addListener(ILabelProviderListener arg0) {

	}

	@Override
	public void dispose() {

	}
	public String getSource(Object inputElement){
		return null;
		
	}

	@Override
	public boolean isLabelProperty(Object arg0, String arg1) {
		return false;
	}

	@Override
	public void removeListener(ILabelProviderListener arg0) {
		
	}

}
