package org.openntf.sourcesniffer.actions;

/*
 * (C)Copyright Ferry Kranenburg 2010
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at:
 * 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * permissions and limitations under the License.
 */

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.openntf.sourcesniffer.views.ssMainWindow;

import com.ibm.designer.domino.ui.commons.extensions.DesignerResource;

public class ssDesignerResourceAction implements IObjectActionDelegate{

	@Override
	public void setActivePart(IAction arg0, IWorkbenchPart arg1) {

	}

	@Override
	public void run(IAction arg0) {

		try {

			//	ISelection iSel = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getSelection();
			ISelection iSel = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
			if (iSel instanceof IStructuredSelection) {
				ssMainWindow.designerSelection = DesignerResource.getDesignerSelection(iSel);
				
			
				// activate source sniffer view
				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView(ssMainWindow.ID, null,IWorkbenchPage.VIEW_ACTIVATE );
				
				// run the actionInputCurrentElement action...
				ssMainWindow.actionInputCurrentElement.run();
				
				// set the text filter on the currently selected design element
				ssMainWindow.textFilter.setText(ssMainWindow.designerSelection.getSelectedDesignElements().get(0).getName().toString());

				
				// refresh the treeviewer!
				ssMainWindow.treeViewer.refresh();
			}
			

		} catch (PartInitException e) {
			e.printStackTrace();
		} 


		
	}

	@Override
	public void selectionChanged(IAction arg0, ISelection arg1) {
		return;
		
	}

}
