package org.openntf.sourcesniffer.actions;

/*
 * (C)Copyright Ferry Kranenburg 2010
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at:
 * 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * permissions and limitations under the License.
 */

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.texteditor.ITextEditor;
import org.openntf.sourcesniffer.views.ssMainWindow;

import com.ibm.designer.domino.ui.commons.extensions.DesignerResource;



public class ssEditorTextAction implements  IWorkbenchWindowActionDelegate {


	public void selectionChanged(IAction action, ISelection iSelection) {

	}

	public void setActiveEditor(IAction action, IEditorPart iEditorPart) {
		
	}

	public void run(IAction iSelection) {
		ISelection sel;
		String strSel = "";

		// trying to get the active text editor
		ITextEditor editor = (ITextEditor)  PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor().getAdapter(ITextEditor.class);
		if (!(editor == null)){
			sel = editor.getSelectionProvider().getSelection();
			if( sel instanceof ITextSelection) {
				// get the text from the eclipse Lotusscript Editor
				strSel = ((ITextSelection)sel).getText();
			}
		}else{
			// maybe text selected from another editor (e.g. java / dxl editor)
			if (iSelection instanceof ITextSelection){
				strSel = ((ITextSelection)iSelection).getText();
			}
		}

		// activate source sniffer view
		try {
			if (strSel != ""){

				//	ISelection iSel = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getSelection();
				ISelection iSel = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
				ssMainWindow.designerSelection = DesignerResource.getDesignerSelection(iSel);

				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView(ssMainWindow.ID, null,IWorkbenchPage.VIEW_ACTIVATE).setFocus();

				
				// run the actionInputCurrentElement action...
				ssMainWindow.actionInputCurrentElement.run();

				// set the text filter on the currently selected design element
				ssMainWindow.textFilter.setText(strSel);

				// refresh the treeviewer!
				ssMainWindow.treeViewer.refresh();
			}



		} catch (PartInitException e) {
			e.printStackTrace();
		}



	}

	public void dispose() {

	}

	public void init(IWorkbenchWindow arg0) {

	}

		


}

