package org.openntf.sourcesniffer;

/*
 * (C)Copyright Ferry Kranenburg 2010
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at:
 * 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * permissions and limitations under the License.
 */

import java.util.ArrayList;

import org.apache.commons.codec.binary.Base64;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.PlatformUI;
import org.openntf.sourcesniffer.views.ssMainWindow;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ssTools {
	
	
	public static String strMiddleOfString(String str_StringToSearchIn,String str_StartAtString,String str_EndAtString,Boolean b_StartStringLastOccurrence, Boolean b_EndStringLastOccurrence, Boolean b_ReturnEmptyWhenNotFound   )  {
	    Integer i_Firstpos = 0;
	    Integer i_Endpos = 0;
	    
	    
	    try{
	    	if (str_StringToSearchIn != "") {
		    	if (str_StartAtString != "") {
			    	if (b_StartStringLastOccurrence = true) {
			    		i_Firstpos = str_StringToSearchIn.toLowerCase().lastIndexOf(str_StartAtString.toLowerCase());
			    	}
			    	else{
			    		i_Firstpos = str_StringToSearchIn.toLowerCase().indexOf(str_StartAtString.toLowerCase()) ; 		
			    	}
			    	if( i_Firstpos == -1) {
			    		if( b_ReturnEmptyWhenNotFound == true){
			    			return "" ;
			    		}
			    	}
			    	else {
			    		str_StringToSearchIn = str_StringToSearchIn.substring((i_Firstpos + str_StartAtString.length() ));
			  
			    	}
			    }
			    if (str_EndAtString != "") {
			    	 i_Endpos = str_StringToSearchIn.toLowerCase().indexOf(str_EndAtString.toLowerCase());
			    	 if( i_Endpos == -1 ) {
			    		 if( b_ReturnEmptyWhenNotFound == true){
				    			return "" ;
			    		 }
			    	 }
			    	 else{
			    		 str_StringToSearchIn = str_StringToSearchIn.substring(0, i_Endpos );
			    	 }
			    }
		    }
		    
		
		
			   	    	
	    }catch(Exception e){
	    	System.out.println(e.getMessage());
	    }

	    
		return str_StringToSearchIn;
	}
	
	// gets all main attributes of design node (sometimes usefull, some code elements store references to other code elements there)
	public static String getAllAttributesToString(Node nodeToGetAttributes){
		String str_DxlAttributes = "";
		if (nodeToGetAttributes.hasAttributes() == true) {
			for(Integer i = 0 ;i != nodeToGetAttributes.getAttributes().getLength(); i++){
				str_DxlAttributes = str_DxlAttributes + nodeToGetAttributes.getAttributes().item(i).getNodeName() + "," + nodeToGetAttributes.getAttributes().item(i).getNodeValue() + "\r\n";
			}
		}

		return str_DxlAttributes;
	}

	// returns attribute text form xml node
	public static String getAttributeByName(Node nodeToGetAttributes, String str_Attributename, boolean bGetTextContent, boolean bChildNodesToo){
		String str_Returnstring = "";
		NamedNodeMap allAttributes = nodeToGetAttributes.getAttributes();
		if( allAttributes != null) {
			for(Integer iAtt =  0 ;iAtt < allAttributes.getLength(); iAtt++){
				Node curAttribute =  allAttributes.item(iAtt);
				if (curAttribute != null){
					if ( curAttribute.getNodeName().toLowerCase().equals(str_Attributename.toLowerCase())) {
						// found the right attribute, now return it
						if (bGetTextContent == true){
							str_Returnstring = curAttribute.getTextContent();
						}else {
							str_Returnstring = curAttribute.getNodeValue();
						}
					}
				}

			}
		}
		if (bChildNodesToo == true){
			if (nodeToGetAttributes.hasChildNodes() == true){
				for(Integer iNode =  0 ;iNode < nodeToGetAttributes.getChildNodes().getLength(); iNode++){
					str_Returnstring = str_Returnstring + getAttributeByName(nodeToGetAttributes.getChildNodes().item(iNode), str_Attributename, bGetTextContent, false);
				}
			}
		}
		
		return str_Returnstring;
	}
	
	// returns the first single attribute text from the xml node / child nodes where str_Attributename exists...
	public static String getFirstAttributeByName(Node nodeToGetAttributes, String str_Attributename){
		
		NamedNodeMap allAttributes = nodeToGetAttributes.getAttributes();
		if( allAttributes != null) {
			for(Integer iAtt =  0 ;iAtt < allAttributes.getLength(); iAtt++){
				Node curAttribute =  allAttributes.item(iAtt);
				if (curAttribute != null){
					if ( curAttribute.getNodeName().toLowerCase().equals(str_Attributename.toLowerCase())) {
						// found the right attribute, now return it
						return  curAttribute.getNodeValue();
					}
				}

			}
		}
		if (nodeToGetAttributes.hasChildNodes() == true){
			for(Integer iNode =  0 ;iNode < nodeToGetAttributes.getChildNodes().getLength(); iNode++){
				return getFirstAttributeByName(nodeToGetAttributes.getChildNodes().item(iNode), str_Attributename);
			}
		}
		
		// if it didn't find anything, then return nothing..
		return "";

		
	}
	
	// will search all nested nodes if the attribute "ss_SourceCode" contains the str_FilterTxt
	public static boolean containsCodeInLastNestedNode(Node nodeToSearch, String str_FilterTxt){
				
		if (nodeToSearch.hasChildNodes() == true){
			NodeList nlChildren = nodeToSearch.getChildNodes();
			for(Integer iChld =  0 ;iChld < nlChildren.getLength(); iChld++){
				Node nCurrentChild = nlChildren.item(iChld);
				if (nCurrentChild.getNodeType() == Node.ELEMENT_NODE){
					if (nCurrentChild.hasChildNodes() == true){
						for(Integer iNode =  0 ;iNode < nCurrentChild.getChildNodes().getLength(); iNode++){
							if( containsCodeInLastNestedNode(nCurrentChild.getChildNodes().item(iNode), str_FilterTxt) == true) {
								return true ;
							}
						}
					}else{
						String str_SourceCode = getAttributeByName(nCurrentChild, "ss_SourceCode", false,false);
						//v1.5 - decode sourcecode if it's base64 encoded
						if (str_SourceCode.startsWith("<<DECODEBASE64>>") == true ){
							str_SourceCode = ssTools.getBase64DecodedString(str_SourceCode);
						}
						
						String str_Attributes = getAttributeByName(nCurrentChild, "ss_Attributes", false, false );
						if (str_SourceCode.toLowerCase().indexOf(str_FilterTxt.toLowerCase()) != -1){
							return true;
						}else if (str_Attributes.toLowerCase().indexOf(str_FilterTxt.toLowerCase()) != -1){
							return true;
						}
					}
				}	
			}
		}else{
			// last node (no child nodes)
			if (nodeToSearch.getNodeType() == Node.ELEMENT_NODE){
				String str_SourceCode = getAttributeByName(nodeToSearch, "ss_SourceCode", false,false);
				//v1.5 - decode sourcecode if it's base64 encoded
				if (str_SourceCode.startsWith("<<DECODEBASE64>>") == true ){
					str_SourceCode = ssTools.getBase64DecodedString(str_SourceCode);
				}
				
				String str_Attributes = getAttributeByName(nodeToSearch, "ss_Attributes", false, false );
				if (str_SourceCode.toLowerCase().indexOf(str_FilterTxt.toLowerCase()) != -1){
					return true;
				}else if (str_Attributes.toLowerCase().indexOf(str_FilterTxt.toLowerCase()) != -1){
					return true;
				}
			}	
		}
			
		
		return false;
		
	}
	
	// will return all nodes that have the given name
	public static void addAllNodesByName(Node nodeToProcess, ArrayList<String> srch, Element xml_ToMemory_EventCodeNode, Document xmlDoc, String str_ImagePath, String str_NotesUrl) {

		if (nodeToProcess.hasChildNodes() == true){
			NodeList nlChildren = nodeToProcess.getChildNodes();
			for(Integer iChld =  0 ;iChld < nlChildren.getLength(); iChld++){
				Node nCurrentChild = nlChildren.item(iChld);
				if (nCurrentChild.getNodeType() == Node.ELEMENT_NODE ) {
					// now check this child's node name and add when equals

					if (srch.indexOf(nCurrentChild.getNodeName().toLowerCase()) != -1 || srch.indexOf(getAttributeByName(nCurrentChild, "name", false, false).toLowerCase()) != -1){
						Element xml_ToMemory_CodeNode;
						String str_CodeEventName;
						String str_CodeContent;
						str_CodeEventName = getAttributeByName(nCurrentChild, "event", false, false);
						if (str_CodeEventName.equals("")) {
							str_CodeEventName = getAttributeByName(nCurrentChild, "ui", false, false );
						}
						if (str_CodeEventName.equals("")) {
							str_CodeEventName = getAttributeByName(nCurrentChild, "name", false, false );
						}
						
						// do not add hide-when formulas
						if (str_CodeEventName.toLowerCase().equals("hidewhen")) {

						}else {

							xml_ToMemory_CodeNode = xmlDoc.createElement("Element");
							xml_ToMemory_CodeNode.setAttribute("ss_Name", str_CodeEventName);
							xml_ToMemory_CodeNode.setAttribute("ss_Image", str_ImagePath);
							xml_ToMemory_CodeNode.setAttribute("ss_NotesUrl", str_NotesUrl);
							xml_ToMemory_CodeNode.setAttribute("ss_Attributes", getAllAttributesToString(nCurrentChild.getParentNode()));
							if (nCurrentChild.hasChildNodes() == true){
								if (str_CodeEventName.toLowerCase().contains("$")){
									// string is base64 decoded, cant decode this now, we can't save a validated xml
									str_CodeContent = "<<DECODEBASE64>>" +  nCurrentChild.getTextContent();   // let source code viewer know it needs to be decoded

								}else{
									str_CodeContent = nCurrentChild.getFirstChild().getTextContent();

								}

							}else{
								str_CodeContent =  nCurrentChild.getTextContent();
								
	
							}
							// set sourcecode attribute
							xml_ToMemory_CodeNode.setAttribute("ss_SourceCode", str_CodeContent);
							
							// v1.3 - count code lines (all)
							xml_ToMemory_CodeNode.setAttribute("ss_SourceCodeLineCount", String.valueOf(str_CodeContent.split("\n").length));
							
							xml_ToMemory_EventCodeNode.appendChild(xml_ToMemory_CodeNode);
						}

					}

				}
			
			}

		}

	}

	//v1.5 - return's a given string Base64Decoded!
	public static String getBase64DecodedString(String sBase64String) {
		
		byte[] bytDecoded = Base64.decodeBase64(sBase64String.getBytes());
		String decodedString = new String(bytDecoded); 
		decodedString = decodedString.replaceAll(Character.toString(((char) 0)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 0)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 1)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 2)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 3)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 4)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 5)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 160)), "");
		decodedString = decodedString.replaceAll(Character.toString(((char) 24)), "");
		
		
		decodedString = strMiddleOfString(decodedString, "encoding=\"UTF-8\"?>", "", false, false, false);
		
		return decodedString;
		
		
	}
	
	// colors given word in styled text box 
	public static StyledText highLightWord(StyledText richText, String str_HighlightText, Color colColor){

		int intpos;

		intpos = richText.getText().toLowerCase().indexOf(str_HighlightText.toLowerCase());
		if( intpos == -1){
			return richText;
		}

		while (intpos > 0) {
			richText.getTextRange(intpos, str_HighlightText.length());
			StyleRange styleRange = new StyleRange();
			styleRange.start = intpos;
			styleRange.length =  str_HighlightText.length();
			styleRange.fontStyle = SWT.BOLD;
			styleRange.foreground = colColor;
			
			richText.setStyleRange(styleRange);

			intpos = richText.getText().toLowerCase().indexOf(str_HighlightText.toLowerCase(), intpos + 1);
		}

		return richText;

	}

	// scrolls the styledtext until the word is found...
	public static int scrollToFirstText(StyledText richText, String str_HighlightText, int i_Frompos){
		int intpos;
		
		// can the text be found?
		intpos = richText.getText().toLowerCase().indexOf(str_HighlightText.toLowerCase(), i_Frompos + 1);
		if( intpos == -1){
			return -1;
		}

		richText.getTextRange(intpos, str_HighlightText.length());
		StyleRange styleRange = new StyleRange();
		styleRange.start = intpos;
		styleRange.length =  str_HighlightText.length();
		styleRange.fontStyle = SWT.BOLD;
		styleRange.background = Display.getCurrent().getSystemColor(SWT.COLOR_GRAY);
		styleRange.foreground = Display.getCurrent().getSystemColor(SWT.COLOR_BLUE);
		richText.setStyleRange(styleRange);

		// this will make the scroll happen
		richText.setSelection(intpos);

		return intpos;
		
	}
	
	// gets the count how many times a given word is found in a richText box - used by getUnusedVariablesInCode
	private static int getWordCount(StyledText richText, String str_Word, int iStartLine ) {
		int intFoundCount = 0;
		String strLine = "";

		for(int iLine = iStartLine ;iLine < richText.getLineCount(); iLine++){
			strLine = richText.getLine(iLine);
			// trim all tabs	
			strLine = strLine.replaceAll(Character.toString(((char) 9)), "");

			// if the code is within a comment block, then skip it (by altering the code line itself in memory)!
			strLine = strMiddleOfString(strLine, "", "'",false,false,false);

			
			
			if (strLine.toLowerCase().indexOf(str_Word.toLowerCase()) != -1) {
				intFoundCount++;
			}
		}


		
		return intFoundCount;
		
	}
	
	public static long getSourceCodeLineCount(Node nodeSelected, long lngCount, boolean bParseCurrentNode){
		
		
		if (nodeSelected.hasChildNodes() == true){
			NodeList nlChildren = nodeSelected.getChildNodes();
			for(Integer iChld =  0 ;iChld < nlChildren.getLength(); iChld++){
				Node nCurrentChild = nlChildren.item(iChld);
				if (nCurrentChild.getNodeType() == Node.ELEMENT_NODE ) {
					// now get the codeline count
					String tmpString = ssTools.getAttributeByName(nCurrentChild, "ss_SourceCodeLineCount", false, false ).trim() ;
					if (tmpString.equals("") == false){
						lngCount += Long.parseLong(tmpString);	
					}
					
					
					if (nCurrentChild.hasChildNodes() == true) {
						lngCount = getSourceCodeLineCount(nCurrentChild, lngCount, false);
					}
					
				}
			}
		}else{
			if (bParseCurrentNode == true){
				// now get the codeline count
				String tmpString = ssTools.getAttributeByName(nodeSelected, "ss_SourceCodeLineCount", false, false ).trim() ;
				if (tmpString.equals("") == false){
					lngCount += Long.parseLong(tmpString);	
				}
			}

		}
		
		
		
		return lngCount;
		
	}
	
	// highlights unused variables in code preview styled textbox & add them to a list
	public static StyledText getUnusedVariablesInCode(StyledText richText ){
		String strLine = "";
		String strVariablename = "";
		int iVariableCount = 0;
		
		// empty all previous items
		ssMainWindow.tblUnusedVariables.removeAll();

		// more then 50.000 lines? skip it!
		if (richText.getLineCount() > 50000) {
			return richText;
		}

		if (richText.getText() == "") {
			return richText;
		}
		
		for(int iLine = 0 ;iLine < richText.getLineCount(); iLine++){
			// get current line of code to string
			strLine = richText.getLine(iLine);
			// trim all tabs	
			strLine = strLine.replaceAll(Character.toString(((char) 9)), "");

			// if the code is within a comment block, then skip it (by altering the code line itself in memory)!
			strLine = strMiddleOfString(strLine, "", "'",false,false,false);

			// if line contains dim and not redim, then it's a variable declaration

			if (strLine.toLowerCase().indexOf("dim") != -1 && strLine.toLowerCase().indexOf("redim") == -1) {
				// get variable name between "dim" and "as"
				strVariablename = strMiddleOfString(strLine, "dim ", " as",false,false,false);
				// the variable may be an array(list), so strip that
				strVariablename = strMiddleOfString(strVariablename, "", "(", false,false,false).trim();


				// retrieve how many hits on this variable name found (unfortunately this is never 100% correct, if you have a variable named PersonName and Person, the you would get all the hits of PersonName too....)
				iVariableCount = getWordCount(richText,strVariablename, iLine);
				
				TableItem tblItem = new TableItem(ssMainWindow.tblUnusedVariables, SWT.NONE);

				tblItem.setText(0, strVariablename);
				tblItem.setText(1, String.valueOf(iVariableCount));

				// if variable is less than 2, then it's not used...
				if (iVariableCount < 2 ) {
					richText = highLightWord(richText,strLine,PlatformUI.getWorkbench().getDisplay().getSystemColor (SWT.COLOR_MAGENTA));
					tblItem.setBackground(PlatformUI.getWorkbench().getDisplay().getSystemColor (SWT.COLOR_RED));
				}



			}
		}


		return null;

	}
		

}
