package org.openntf.sourcesniffer.views;

/*
 * (C)Copyright Ferry Kranenburg 2010
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at:
 * 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * permissions and limitations under the License.
 */

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;
import org.openntf.sourcesniffer.ssTools;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.util.ArrayList;



public class ssTreeContentProvider  implements ITreeContentProvider {
	
	

	@Override
	public Object[] getChildren(Object parentElement) {
		ArrayList<Node> aChildren = new ArrayList<Node>();
		getAllChildNodes((Node) parentElement, aChildren, true);	
		
		return aChildren.toArray();
	
		
	}

	@Override
	public Object getParent(Object inputElement) {
		return ((Node) inputElement).getParentNode();

	}

	@Override
	public boolean hasChildren(Object inputElement) {
		return ((Node) inputElement).hasChildNodes();

	}


	@Override
	public Object[] getElements(Object inputElement) {
		ArrayList<Node> nodes = new ArrayList<Node>();
		getAllChildNodes((Node) inputElement, nodes, true);	
		

		return nodes.toArray();

		
 
	}

	@Override
	public void dispose() {

		
	}

	@Override
	public void inputChanged(Viewer arg0, Object arg1, Object arg2) {

		
	}
	
	// FUNCTION TO RETRIEVE ALL CHILD NODES OF XML NODES TO ARRAYLIST
	public void getAllChildNodes(Node xml_ChildNode, ArrayList<Node> aChildren, boolean bFiltered ) {
		try{
			String str_FilterTxt = ssMainWindow.str_Filter;

			
			if (xml_ChildNode.hasChildNodes() == true){
				NodeList nlChildren = xml_ChildNode.getChildNodes();
				for(Integer iChld =  0 ;iChld < nlChildren.getLength(); iChld++){
					Node nCurrentChild = nlChildren.item(iChld);
					if (nCurrentChild.getNodeType() == Node.ELEMENT_NODE){
						if (bFiltered == true) {
							if (str_FilterTxt.equals("")){
								aChildren.add(nCurrentChild);
							}else{
								if (ssTools.containsCodeInLastNestedNode(nCurrentChild, str_FilterTxt) == true){
									aChildren.add(nCurrentChild);
								}
							}
						}else{
							aChildren.add(nCurrentChild);
						}
						
					}
				}
			}
		}finally{
			// done

		}
		

		
		
		
		
	}
}
