package org.openntf.sourcesniffer.views;

/*
 * (C)Copyright Ferry Kranenburg 2010
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at:
 * 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * permissions and limitations under the License.
 */

import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.swt.graphics.Image;
import org.openntf.sourcesniffer.Activator;
import org.openntf.sourcesniffer.ssTools;
import org.w3c.dom.Node;

public class ssTreeLabelProvider implements ILabelProvider {

	@Override
	public Image getImage(Object inputElement) {
		String imagePath =  ssTools.getAttributeByName((Node) inputElement, "ss_Image", true, false );
		if (imagePath != ""){
			return new Image(null, Activator.getImage(imagePath), 0);
		}else{
			return null;
		}
	}

	@Override
	public String getText(Object inputElement) {
		return ssTools.getAttributeByName((Node)inputElement, "ss_Name", true, false);
	}

	@Override
	public void addListener(ILabelProviderListener arg0) {

	}

	@Override
	public void dispose() {

	}
	public String getSource(Object inputElement){
		return ssTools.getAttributeByName((Node)inputElement, "ss_Image", true, false);
	}

	@Override
	public boolean isLabelProperty(Object arg0, String arg1) {
		return false;
	}

	@Override
	public void removeListener(ILabelProviderListener arg0) {
		
	}

}
