package org.openntf.sourcesniffer.views;

/*
 * (C)Copyright Ferry Kranenburg 2010
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at:
 * 
 * http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing 
 * permissions and limitations under the License.
 */

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IWorkingSet;
import org.eclipse.ui.internal.WorkingSet;
import org.w3c.dom.Node;

import java.util.ArrayList;



@SuppressWarnings("restriction")
public class ssTreeWorkingSetContentProvider  implements ITreeContentProvider {
	
	

	@Override
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof WorkingSet){
			return ((WorkingSet) parentElement).getElements();
			
		}else{
			return null;
		}

	}

	@Override
	public Object getParent(Object inputElement) {
		return ((Node) inputElement).getParentNode();

	}

	@Override
	public boolean hasChildren(Object inputElement) {
		if (inputElement instanceof WorkingSet){
			return true;
		}else{
			return false;
		}
			


	}


	@Override
	public Object[] getElements(Object inputElement) {
		ArrayList<IWorkingSet> nodes = new ArrayList<IWorkingSet>();
		
		IWorkingSet[] workingSets = ((IWorkingSet[]) inputElement);
		
		for(Integer iWorkSet =  0 ;iWorkSet < workingSets.length; iWorkSet++){
	 		IWorkingSet curWorkingSet = workingSets[iWorkSet];
	 		nodes.add(curWorkingSet);
		}

		return nodes.toArray();
	
 
	}

	@Override
	public void dispose() {
		
	}

	@Override
	public void inputChanged(Viewer arg0, Object arg1, Object arg2) {
		
	}

}
